/*
 * Add Product to shopping cart + get response for further steps
 * id = add_to_cart
 * data-to-send = Define Json Jbject with will be send to shopping cart Api
 * data-source = URL where to send the json request
 */

var shopping_cart_id = "shopping_cart_";
var shopping_cart_content_name = "content";
var shopping_cart_amount = "count";

var cartContentHtml =   '<li>' +
                            '<a id="product_path" href="#">' +
                                '<div class="widget-body">' +
                                    '<div class="pull-left icon">' +
                                        '<i class="icon-user text-success"></i>' +
                                    '</div>' +
                                    '<div id="product_descr" class="pull-left text">' +
                                        '<small id="product_price" class="text-muted">' +
                                        '</small>' +
                                    '</div>' +
                                '</div>' +
                            '</a>' +
                        '</li>'+
                        '<li class="divider"></li>';

var endContentHtml =    '<li>'+
                            '<a href="/en/'+shopping_cart_id+'show">'+
                                'Cart'+
                                '<small id='+shopping_cart_id+'price" class="text-muted">' +
                                '</small>' +
                            '</a>'+
                        '</li>';

/*
 * Ajax call handling
 */

var default_product_atts = ["count", "descr", "price"];
var default_cart_atts = ["price"];

$(document).on("click", "#"+shopping_cart_id+"function", function(){
    var cart_id = "#"+shopping_cart_id+"function";

    //1. Get Attributes
    var data;
    if($(cart_id).attr('data-to-send')){
        data = $(cart_id).data('toSend');
    }else{
        alert("You need to define the 'data-to-send' attribute ");
        return;
    }
    var sourceUrl;
    if($(cart_id).attr('data-source')){
        sourceUrl = $(cart_id).data('source');
    }else{
        alert("You need to define the 'data-source' attribute ");
        return;
    }

    //2. Check if the data attributes is a Hash
    if(!jQuery.isPlainObject(data)){
        alert("The data-to-send object is invalid. needs to be like -> {'attr':'value'} ");
        return;
    }

    //3. Fire up Json-Request
    $.ajax({
        type: "POST",
        url: sourceUrl,
        beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'))},
        data: data,
        dataType: 'json',
        success: function(data, textStatus, jqXHR)
        {
            //data - response from server
            generateCart(data);
        },
        error: function (jqXHR, textStatus, errorThrown)
        {
            alert("Something went wrong: "+textStatus);
        }
    });
});

/*
 * Parse Recieved Cart stuff
 * data-product-attributes  = Defined product attributes to display
 * data-cart-attributes = Define article attributes to display
 */
function generateCart(data) {
    var cart_id = "#"+shopping_cart_id+"function";
    //Generate Content
    var content = $("#"+shopping_cart_id+shopping_cart_content_name);
    //Get the attributes
    var pro_atts = ($(cart_id).data('productAttributes'));
    var cart_atts = ($(cart_id).data('cartAttributes'));
    if(!pro_atts){
        pro_atts = default_product_atts;
    }
    if(!cart_atts){
        cart_atts = default_cart_atts;
    }
    if(!jQuery.isArray(pro_atts)){
        alert("The data-product-attributes object is invalid. needs to be like -> ['att1','att2'] ");
        return;
    }
    if(!jQuery.isArray(cart_atts)){
        alert("The data-cart-attributes object is invalid. needs to be like -> ['att1','att2'] ");
        return;
    }
    //Set the attribute in the generated Html for each product
    content.empty();
    $.each(data.products, function( index, pro ) {
        var subContent = $.parseHTML( cartContentHtml);
        $.each(pro_atts, function( index, att_value ) {
            //1. Check if the attribute exits in html
            var id_string = "#product_"+att_value;
            $.each(subContent, function( index, sub ) {
                var innterContent = $(sub).find(id_string);
                if (innterContent.length > 0) {
                    //Check if it hass innerHTML
                    if (innterContent.children().length > 0) {
                        var children = innterContent.children();
                        innterContent.text(pro[att_value]);
                        innterContent.append(children);
                    } else {
                        innterContent.text(pro[att_value]);
                    }
                }
                //break
                return false;
            });
        });
        content.append(subContent);
    });
    //Last stept ist to itterate through the content object and the endContent to set the cart attributes
    $("#"+shopping_cart_id+shopping_cart_amount).text(data.products.length);
    $.each(cart_atts, function( index, att_value ) {
        var id_string = "#"+shopping_cart_id+att_value;
        var innterContent = $(content).find(id_string);
        if(innterContent.length > 0){
            //Check if it hass innerHTML
            if(innterContent.children().length > 0){
                var children = innterContent.children();
                innterContent.text(data[att_value]);
                innterContent.append(children);
            }else{
                innterContent.text(data[att_value]);
            }
        }else{
            //iterate through endContent
            var subContent = $.parseHTML( endContentHtml);
            $.each(subContent, function( index, sub ) {
                var innterContent2 = $(sub).find(id_string);
                if (innterContent2) {
                    //Check if it hass innerHTML
                    if (innterContent2.children().length > 0) {
                        var children = innterContent2.children();
                        innterContent2.text(data[att_value]);
                        innterContent2.append(children);
                    } else {
                        innterContent2.text(data[att_value]);
                    }
                }
                //break
                return false;
            });
            content.append(subContent);
        }
    });
}